const R = require('rambda')

const isType = require('./modules/isType')

exports.compact = require('./modules/compact')
exports.composeAsync = require('./modules/composeAsync')
exports.debounce = require('./modules/debounce')
exports.DELAY = 'RAMBDAX_DELAY'
exports.delay = require('./modules/delay')
exports.evolve = require('./modules/evolve')
exports.ifElseAsync = require('./modules/ifElseAsync')
exports.intersection = require('./modules/intersection')
exports.isArray = x => isType('Array', x)
exports.isObject = x => isType('Object', x)
exports.isPromiseLike = require('./modules/isPromiseLike')
exports.isString = x => isType('String', x)
exports.isType = isType
exports.isValid = require('./modules/isValid')
exports.mapAsync = require('./modules/mapAsync')
exports.mapFastAsync = require('./modules/mapFastAsync')
exports.memoize = require('./modules/memoize')
exports.mergeAll = require('./modules/mergeAll')
exports.omitBy = require('./modules/omitBy')
exports.once = require('./modules/once')
exports.pickBy = require('./modules/pickBy')
exports.produce = require('./modules/produce')
exports.race = require('./modules/race')
exports.random = require('./modules/random')
exports.rangeBy = require('./modules/rangeBy')
exports.renameProps = require('./modules/renameProps')
exports.resolve = require('./modules/resolve')
exports.resolveSecure = require('./modules/resolveSecure')
exports.shuffle = require('./modules/shuffle')
exports.tap = require('./modules/tap')
exports.tapAsync = require('./modules/tapAsync')
exports.throttle = require('./modules/throttle')
exports.when = require('./modules/when')
exports.where = require('./modules/where')
exports.wrap = require('./modules/wrap')

Object.keys(R).map(method => {
  exports[ method ] = R[ method ]
})
